{********************************************************************************}
{ Othello 1.0 - Juego del Othello bajo ms-dos.                                   }
{ Copyright (C) 2005  Gorka Surez Garca                                        }
{                                                                                }
{ Nucleo.pas is part of "Othello".                                               }
{                                                                                }
{ "Othello" is free software; you can redistribute it and/or                     }
{ modify it under the terms of the GNU General Public License                    }
{ as published by the Free Software Foundation; either version 2                 }
{ of the License, or (at your option) any later version.                         }
{                                                                                }
{ "Othello" is distributed in the hope that it will be useful,                   }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of                 }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                  }
{ GNU General Public License for more details.                                   }
{                                                                                }
{ You should have received a copy of the GNU General Public License              }
{ along with "Othello"; if not, write to the Free Software                       }
{ Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.    }
{********************************************************************************}
unit Nucleo;
{********************************************************************************}
interface {parte publica}
uses Lesslib, crt;
{********************************************************************************}
{ Constantes del juego.                                                          }
{********************************************************************************}
const
   {-----------------------------------------------------------------------------}
   { Constantes relacionadas con las fichas del othello.                         }
   {-----------------------------------------------------------------------------}
   FICHA_VACIA  = 0;
   FICHA_BLANCA = 1;
   FICHA_NEGRA  = 2;

   MAX_FICHAS = 2;

   FICHA_ANCHO = 20;
   FICHA_ALTO  = 20;
   
   TAB_CENTROX = 100;
   TAB_CENTROY = 100;

   TAB_TAMINI =  2;
   TAB_TAMFIN = 10;

   {-----------------------------------------------------------------------------}
   { Constantes relacionadas con los turnos del juego.                           }
   {-----------------------------------------------------------------------------}
   TURNO_BLANCAS = 1;
   TURNO_NEGRAS  = 2;

   {-----------------------------------------------------------------------------}
   { Constantes relacionadas con el tablero del othello.                         }
   {-----------------------------------------------------------------------------}
   MAX_FILAS    = 10;
   MAX_COLUMNAS = 10;

   TAB_SEP_X = 20;
   TAB_SEP_Y = 20;

   {-----------------------------------------------------------------------------}
   { Constantes relacionadas con las texturas de las casillas.                   }
   {-----------------------------------------------------------------------------}
   MAX_CASTEX = 2;

   CASTEX_BLANCA = 1;
   CASTEX_AZUL   = 2;

   CASTEX_COORDX =  0;
   CASTEX_COORDY = 20;
   
   CASTEX_ANCHO = 20;
   CASTEX_ALTO  = 20;

   {-----------------------------------------------------------------------------}
   { Constantes relacionadas con los botones de la interfaz.                     }
   {-----------------------------------------------------------------------------}
   MAX_BOTONES = 18;
   MNU_BOTONES =  5;
   TAB_BOTONES =  5;
   DLG_BOTONES =  2;
   DIF_BOTONES =  3;

   BOT_NINGUNO    =  0;
   BOT_1JUGADORES =  1;
   BOT_2JUGADORES =  2;
   BOT_REINICIAR  =  3;
   BOT_SALVAR     =  4;
   BOT_CARGAR     =  5;
   BOT_AYUDA      =  6;
   BOT_SALIR      =  7;
   BOT_SI_NORMAL  =  8;
   BOT_SI         =  9;
   BOT_NO_NORMAL  = 10;
   BOT_NO         = 11;
   BOT_PASAR      = 12;
   BOT_FACIL_SP   = 13;
   BOT_FACIL      = 14;
   BOT_NORMAL_SP  = 15;
   BOT_NORMAL     = 16;
   BOT_DIFICIL_SP = 17;
   BOT_DIFICIL    = 18;

   BOT_MNU_1JUGADORES = 1;
   BOT_MNU_2JUGADORES = 2;
   BOT_MNU_CARGAR     = 3;
   BOT_MNU_AYUDA      = 4;
   BOT_MNU_SALIR      = 5;

   BOT_TAB_REINICIAR  = 1;
   BOT_TAB_SALVAR     = 2;
   BOT_TAB_CARGAR     = 3;
   BOT_TAB_PASAR      = 4;
   BOT_TAB_SALIR      = 5;

   BOT_DIF_FACIL   = 1;
   BOT_DIF_NORMAL  = 2;
   BOT_DIF_DIFICIL = 3;

   BOT_DLG_SI = 1;
   BOT_DLG_NO = 2;

   BOTON_ANCHO = 96;
   BOTON_ALTO  = 24;
   BOTON_SEP_Y = 32;

   BOTMNU_INITX  = 112;
   BOTMNU_INITY  =  32;
   BOTMNU_SALIRY = 168;

   BOTTAB_INITX  = 216;
   BOTTAB_INITY  =   8;
   BOTTAB_SALIRY = 144;

   BOTDLG_INITX =  54;
   BOTDLG_SEP_X = 116;
   BOTDLG_INITY = 126;

   {-----------------------------------------------------------------------------}
   { Constantes relacionadas con la pantalla para introducir la dificultad.      }
   {-----------------------------------------------------------------------------}
   DIFBOT_TITX  = 84;
   DIFBOT_TITY  = 32;

   DIFBOT_INITX = 112;
   DIFBOT_INITY =  64;
   DIFBOT_SEP_Y =  40;

   DIFICULTAD_FACIL   = 3;
   DIFICULTAD_NORMAL  = 5;
   DIFICULTAD_DIFICIL = 7;

   {-----------------------------------------------------------------------------}
   { Constantes relacionadas con la pantalla para introducir el tamao.          }
   {-----------------------------------------------------------------------------}
   MAX_TAMBOT = 2;

   TAMBOT_FILAS = 2;
   
   TAMBOT_COLINI =  2;
   TAMBOT_COLFIN = 10;

   TAMBOT_COORDX = 40;
   TAMBOT_COORDY =  0;

   TAMBOT_ANCHO = 24;
   TAMBOT_ALTO  = 24;

   TAMBOT_TXT1X = 104;
   TAMBOT_TXT1Y =  20;   
   TAMBOT_TXT2X = 108;
   TAMBOT_TXT2Y = 120;

   TAMBOT_INITX =  20;
   TAMBOT_INI1Y =  55;
   TAMBOT_SEP_X =  32;
   TAMBOT_INI2Y = 155;
   TAMBOT_SEPTX =   8;
   TAMBOT_SEPTY =   5;

   TAMBOT_SINPULSAR = 1;
   TAMBOT_PULSADO   = 2;

   {-----------------------------------------------------------------------------}
   { Constantes relacionadas con las partidas guardadas.                         }
   {-----------------------------------------------------------------------------}
   MAX_PARTIDAS = 10;

   PART_INITX =  10;
   PART_INITY =  20;
   PART_INITW = 300;
   PART_INITH =  16;
   PART_SEP_Y =  18;

   PART_EST_NORMAL = 0;
   PART_EST_AVISO  = 1;
   PART_EST_METER  = 2;

   {-----------------------------------------------------------------------------}
   { Constantes relacionadas con el cursor del ratn.                            }
   {-----------------------------------------------------------------------------}
   MAX_CUR = 2;

   CUR_NORMAL = 1;
   CUR_COGER  = 2;

   CURSOR_ANCHO = 16;
   CURSOR_ALTO  = 16;

   {-----------------------------------------------------------------------------}
   { Constantes relacionadas con las teclas del teclado.                         }
   {-----------------------------------------------------------------------------}
   TECLA_ESC       = 27;
   TECLA_ENTER     = 13;
   TECLA_RETROCESO =  8;

   {-----------------------------------------------------------------------------}
   { Constantes relacionadas con los estados del juego.                          }
   {-----------------------------------------------------------------------------}
   EST_MENU       =  0;
   EST_1JUG       = 11;
   EST_2JUG       = 12;
   EST_ELITAM1    = 13;
   EST_ELINOM1J1  = 14;
   EST_ELIDIFICUL = 15;
   EST_ELITAM2    = 16;
   EST_ELINOM2J1  = 17;
   EST_ELINOM2J2  = 18;
   EST_SALVAR1    = 21;
   EST_SALVAR2    = 22;
   EST_CARGAR1    = 31;
   EST_CARGAR2    = 32;
   EST_CARGAR3    = 33;
   EST_AYUDA1     = 41;
   EST_SALIR1     = 51;
   EST_SALIR2     = 52;
   EST_SALIR3     = 53;
   EST_REINICIAR1 = 61;
   EST_REINICIAR2 = 62;
   EST_FIN        = 80;

   {-----------------------------------------------------------------------------}
   { Constantes relacionadas con los colores de la paleta.                       }
   {-----------------------------------------------------------------------------}
   COL_NEGRO       =   0; {Negro}
   COL_GRANATE     =   1; {Rojo fuerte}
   COL_VERDE       =   2; {Verde fuerte}
   COL_MARRON      =   3; {Marron}
   COL_MARINO      =   4; {Azul marino}
   COL_PURPURA     =   5; {Purpura}
   COL_AZULADO     =   6; {Azul apagado}
   COL_VERDOSO     = 245; {Azul verdoso}
   COL_GRIS_CLARO  = 247; {Gris claro}
   COL_GRIS        = 248; {Gris fuerte}
   COL_ROJO        = 249; {Rojo}
   COL_VERDE_CLARO = 250; {Verde claro}
   COL_AMARILLO    = 251; {Amarillo}
   COL_AZUL        = 252; {Azul fuerte}
   COL_ROSA        = 253; {Rosa}
   COL_TURQUESA    = 254; {Azul claro}
   COL_BLANCO      = 255; {Blanco}

   {-----------------------------------------------------------------------------}
   { Constantes relacionadas con los colores de ciertas cadenas de texto.        }
   {-----------------------------------------------------------------------------}
   COL_TXTDLG = 255; {COL_BLANCO}
   COL_TXTTIT =   2; {COL_VERDE}
   COL_TXTAYU =   6; {COL_AZULADO}
   COL_TXTEJE = 252; {COL_AZUL}
   COL_TXTCON =   3; {COL_MARRON}
   COL_TXTSAL = 255; {COL_BLANCO}
   COL_TXTNOM = 255; {COL_BLANCO}
   COL_TXTCAR = 255; {COL_BLANCO}
   COL_TXTMSJ =   3; {COL_MARRON}
   COL_TXTVIC = 255; {COL_BLANCO}

   {-----------------------------------------------------------------------------}
   { Constantes relacionadas con la victoria en el juego.                        }
   {-----------------------------------------------------------------------------}
   VICTORIA_NO  = 0;
   VICTORIA_J1  = 1;
   VICTORIA_J2  = 2;
   JUEGO_TABLAS = 3;

   {-----------------------------------------------------------------------------}
   { Constantes relacionadas con los mensajes del juego al jugador.              }
   {-----------------------------------------------------------------------------}
   MSJ_NINGUNO = 0;
   MSJ_MOVINV  = 1; {Movimiento invalido}
   MSJ_BLABLOQ = 2; {Blancas bloqueadas}
   MSJ_NEGBLOQ = 3; {Negras bloqueadas}
   MSJ_NOPASAR = 4; {No se puede pasar en este turno}

   {-----------------------------------------------------------------------------}
   { Otras constantes del juego.                                                 }
   {-----------------------------------------------------------------------------}
   TIEMPO = 200;

{********************************************************************************}
{ Tipos estructurados del juego.                                                 }
{********************************************************************************}
type
   {-----------------------------------------------------------------------------}
   { Tipos relacionados con el estado de las fichas.                             }
   {-----------------------------------------------------------------------------}

   tTablero = array[1..MAX_FILAS, 1..MAX_COLUMNAS] of byte;
   
   {-----------------------------------------------------------------------------}
   { Tipo que almacena todos los datos relacionados con las texturas.            }
   {-----------------------------------------------------------------------------}
   tTexturas = record
         CClave: byte;

         Botones: tImagen;
         Fichas:  tImagen;
         Menu:    tImagen;
         Tablero: tImagen;
         Cursor:  tImagen;

         PosBotones: array[1..MAX_BOTONES] of tRect;
         MnuBotones: array[1..MNU_BOTONES] of tRect;
         TabBotones: array[1..TAB_BOTONES] of tRect;
         DlgBotones: array[1..DLG_BOTONES] of tRect;
         PosFichas:  array[1..MAX_FICHAS] of tRect;
         PosTamBot:  array[1..MAX_TAMBOT] of tRect;
         PosCasTex:  array[1..MAX_CASTEX] of tRect;
         PosDifBot:  array[1..DIF_BOTONES] of tRect;
         PosCursor:  array[1..MAX_CUR] of tRect;
      end;

   {-----------------------------------------------------------------------------}
   { Tipo que almacena todo los datos de la partida actual.                      }
   {-----------------------------------------------------------------------------}
   tJuego = record
         BlanBloq:   boolean;
         NegrBloq:   boolean;
         Victoria:   byte;
         Mensaje:    byte;
         Estado:     byte;
         Turno:      byte;
         Fichas:     tTablero;
         MaxFilas:   byte;
         MaxColum:   byte;
         TabPosX:    byte;
         TabPosY:    byte;
         NombreJ1:   string;
         NombreJ2:   string;
         Dificultad: byte;
      end;

   {-----------------------------------------------------------------------------}
   { Tipo que almacena todo los datos relacionados con las partidas guardadas.   }
   {-----------------------------------------------------------------------------}
   tPartidas = record
         Estado:  byte;
         Auxcad:  string;
         Parsel:  byte;
         Nombre:  array[1..MAX_PARTIDAS] of string;
         Fichero: array[1..MAX_PARTIDAS] of string;
      end;

   tRegPartida = record
         Nombre: string;
         Juego:  tJuego;
      end;

   tFichPartida = file of tRegPartida;

   {-----------------------------------------------------------------------------}
   { Tipo que almacena todos los datos del programa.                             }
   {-----------------------------------------------------------------------------}
   tNucleo = record
         Juego:      tJuego;
         Partidas:   tPartidas;
         Texturas:   tTexturas;
         Fuente:     tFuente;
         Paleta:     tPaleta;
         Raton:      tRaton;

         Errlog:     text;
      end;


{********************************************************************************}
{ Funcines que se ejecutan al principio o al final del juego.                   }
{********************************************************************************}
procedure CargarTexturas (var Nucleo: tNucleo);
procedure InitPartidas   (var Nucleo: tNucleo);
function  InitJuego      (var Nucleo: tNucleo): boolean;
procedure FinJuego       (var Nucleo: tNucleo);
procedure DoDelay        (ms: word);


{********************************************************************************}
implementation {parte privada}
{********************************************************************************}


{********************************************************************************}
{ Funcin que emula un delay.                                                    }
{********************************************************************************}
procedure DoDelay (ms: word);
var
   ti, tact, tf: dword;
begin
   {-----------------------------------------------------------------------------}
   { Tomamos los valores de tiempo.                                              }
   {-----------------------------------------------------------------------------}
   ti   := DarTiempo;
   tf   := DarTiempo + ms;
   tact := ti;

   {-----------------------------------------------------------------------------}
   { Mientras el tiempo actual, sea menor que el tiempo final, estaremos         }
   { esperando. Y el tiempo inicial tiene que ser menor o igual que el tiempo    }
   { actual, para que en caso de que el reloj de la vuelta no se cuelgue el      }
   { programa, esperando que pasel varios millones de milisegundos.              }
   {-----------------------------------------------------------------------------}
   while (tact < tf) and (ti <= tact) do
      tact := DarTiempo;
end;

{********************************************************************************}
{ Funcin que carga las texturas del juego.                                      }
{********************************************************************************}
procedure CargarTexturas (var Nucleo: tNucleo);
var
   i: integer;
begin
   {-----------------------------------------------------------------------------}
   { Carga de las imagenes.                                                      }
   {-----------------------------------------------------------------------------}
   M13hImagenCargarFichero('img\Menu.bmp', Nucleo.Texturas.Menu, Nucleo.Paleta);
   M13hImagenCargar('img\Tablero.bmp', Nucleo.Texturas.Tablero);
   M13hImagenCargar('img\Botones.bmp', Nucleo.Texturas.Botones);
   M13hImagenCargar('img\Fichas.bmp', Nucleo.Texturas.Fichas);
   M13hImagenCargar('img\Cursor.bmp', Nucleo.Texturas.Cursor);

   {-----------------------------------------------------------------------------}
   { Carga de la paleta.                                                         }
   {-----------------------------------------------------------------------------}
   M13hPaleta24a18(Nucleo.Paleta);
   M13hPaletaCargar(Nucleo.Paleta);

   {-----------------------------------------------------------------------------}
   { Seleccionamos el color clave.                                               }
   {-----------------------------------------------------------------------------}
   Nucleo.Texturas.CClave := M13hImagenDarPixel(0, 0, Nucleo.Texturas.Fichas);

   {-----------------------------------------------------------------------------}
   { Establecer las regiones de los botones.                                     }
   {-----------------------------------------------------------------------------}
   for i := 1 to MAX_BOTONES do
    begin
      Nucleo.Texturas.PosBotones[i].x := 0;
      Nucleo.Texturas.PosBotones[i].y := BOTON_ALTO * (i - 1);
      Nucleo.Texturas.PosBotones[i].w := BOTON_ANCHO;
      Nucleo.Texturas.PosBotones[i].h := BOTON_ALTO;
    end;

   {-----------------------------------------------------------------------------}
   { Establecer las regiones de los botones del men.                            }
   {-----------------------------------------------------------------------------}
   for i := 1 to MNU_BOTONES do
    begin
      Nucleo.Texturas.MnuBotones[i].x := BOTMNU_INITX;
      Nucleo.Texturas.MnuBotones[i].y := BOTON_SEP_Y * (i - 1) + BOTMNU_INITY;
      Nucleo.Texturas.MnuBotones[i].w := BOTON_ANCHO;
      Nucleo.Texturas.MnuBotones[i].h := BOTON_ALTO;
    end;

   Nucleo.Texturas.MnuBotones[BOT_MNU_SALIR].y := BOTMNU_SALIRY;

   {-----------------------------------------------------------------------------}
   { Establecer las regiones de los botones del tablero.                         }
   {-----------------------------------------------------------------------------}
   for i := 1 to TAB_BOTONES do
    begin
      Nucleo.Texturas.TabBotones[i].x := BOTTAB_INITX;
      Nucleo.Texturas.TabBotones[i].y := BOTON_SEP_Y * (i - 1) + BOTTAB_INITY;
      Nucleo.Texturas.TabBotones[i].w := BOTON_ANCHO;
      Nucleo.Texturas.TabBotones[i].h := BOTON_ALTO;
    end;

   Nucleo.Texturas.TabBotones[BOT_TAB_SALIR].y := BOTTAB_SALIRY;

   {-----------------------------------------------------------------------------}
   { Establecer las regiones de los botones del cuadro de dilogo.               }
   {-----------------------------------------------------------------------------}
   for i := 1 to DLG_BOTONES do { SI = (54, 126), NO = (170, 126) }
    begin
      Nucleo.Texturas.DlgBotones[i].x := BOTDLG_SEP_X * (i - 1) + BOTDLG_INITX;
      Nucleo.Texturas.DlgBotones[i].y := BOTDLG_INITY;
      Nucleo.Texturas.DlgBotones[i].w := BOTON_ANCHO;
      Nucleo.Texturas.DlgBotones[i].h := BOTON_ALTO;
    end;

   {-----------------------------------------------------------------------------}
   { Establecer las regiones de las fichas.                                      }
   {-----------------------------------------------------------------------------}
   for i := 1 to MAX_FICHAS do
    begin
      Nucleo.Texturas.PosFichas[i].x := FICHA_ANCHO * (i - 1);
      Nucleo.Texturas.PosFichas[i].y := 0;
      Nucleo.Texturas.PosFichas[i].w := FICHA_ANCHO;
      Nucleo.Texturas.PosFichas[i].h := FICHA_ALTO;
    end;

   {-----------------------------------------------------------------------------}
   { Establecer las regiones de los cursores.                                    }
   {-----------------------------------------------------------------------------}
   for i := 1 to MAX_CUR do
    begin
      Nucleo.Texturas.PosCursor[i].x := CURSOR_ANCHO * (i - 1);
      Nucleo.Texturas.PosCursor[i].y := 0;
      Nucleo.Texturas.PosCursor[i].w := CURSOR_ANCHO;
      Nucleo.Texturas.PosCursor[i].h := CURSOR_ALTO;
    end;

   {-----------------------------------------------------------------------------}
   { Establecer las regiones de los botones de tamao del tablero.               }
   {-----------------------------------------------------------------------------}
   for i := 1 to MAX_TAMBOT do
    begin
      Nucleo.Texturas.PosTamBot[i].x := TAMBOT_COORDX;
      Nucleo.Texturas.PosTamBot[i].y := TAMBOT_ALTO * (i - 1) + TAMBOT_COORDY;
      Nucleo.Texturas.PosTamBot[i].w := TAMBOT_ANCHO;
      Nucleo.Texturas.PosTamBot[i].h := TAMBOT_ALTO;
    end;

   {-----------------------------------------------------------------------------}
   { Establecer las regiones de las texturas de las casillas.                    }
   {-----------------------------------------------------------------------------}
   for i := 1 to MAX_CASTEX do
    begin
      Nucleo.Texturas.PosCasTex[i].x := CASTEX_ANCHO * (i - 1) + CASTEX_COORDX;
      Nucleo.Texturas.PosCasTex[i].y := CASTEX_COORDY;
      Nucleo.Texturas.PosCasTex[i].w := CASTEX_ANCHO;
      Nucleo.Texturas.PosCasTex[i].h := CASTEX_ALTO;
    end;

   {-----------------------------------------------------------------------------}
   { Establecer las regiones de las texturas de las casillas.                    }
   {-----------------------------------------------------------------------------}
   for i := 1 to DIF_BOTONES do
    begin
      Nucleo.Texturas.PosDifBot[i].x := DIFBOT_INITX;
      Nucleo.Texturas.PosDifBot[i].y := DIFBOT_INITY + DIFBOT_SEP_Y * (i - 1);
      Nucleo.Texturas.PosDifBot[i].w := BOTON_ANCHO;
      Nucleo.Texturas.PosDifBot[i].h := BOTON_ALTO;
    end;
   {-----------------------------------------------------------------------------}
   { Carga de la fuente.                                                         }
   {-----------------------------------------------------------------------------}
   FuenteCargar('img\Letras.bmp', Nucleo.Fuente);
end;

{********************************************************************************}
{ Funcin que inicializa los datos de la partidas guardadas.                     }
{********************************************************************************}
procedure InitPartidas (var Nucleo: tNucleo);
var
   i: integer;
   aux: string;
   f: tFichPartida;
   reg: tRegPartida;
begin
   {-----------------------------------------------------------------------------}
   { Inicializamos las variables que tienen que ver con el men.                 }
   {-----------------------------------------------------------------------------}
   Nucleo.Partidas.Estado := PART_EST_NORMAL;
   Nucleo.Partidas.Auxcad := '';

   {-----------------------------------------------------------------------------}
   { Inicializamos los nombres de los ficheros.                                  }
   {-----------------------------------------------------------------------------}
   for i := 1 to MAX_PARTIDAS do
    begin
      str(i - 1, aux);
      Nucleo.Partidas.Fichero[i] := 'save\Save0' + aux + '.sav';
    end;

   {-----------------------------------------------------------------------------}
   { Inicializamos los nombres de las partidas.                                  }
   {-----------------------------------------------------------------------------}
   for i := 1 to MAX_PARTIDAS do
    begin
      {--------------------------------------------------------------------------}
      { Asignamos el fichero a la variable f.                                    }
      {--------------------------------------------------------------------------}
      assign(f, Nucleo.Partidas.Fichero[i]);

      {--------------------------------------------------------------------------}
      { Lo abrimos para leer.                                                    }
      {--------------------------------------------------------------------------}
      {$I-}
      reset(f);
      {$I+}

      {--------------------------------------------------------------------------}
      { Si no hay ningn fallo leemos su contenido y pillamos el nombre.         }
      {--------------------------------------------------------------------------}
      if IOResult = 0 then
       begin
         if filesize(f) > 0 then
          begin
            read(f, reg);
            Nucleo.Partidas.Nombre[i] := reg.Nombre;
          end
         else
            Nucleo.Partidas.Nombre[i] := '---';

         close(f);
       end
      {--------------------------------------------------------------------------}
      { En caso de error inicializamos el nombre con una cadena de "error".      }
      {--------------------------------------------------------------------------}
      else
       begin
         Nucleo.Partidas.Nombre[i] := '---';
         rewrite(f);
         close(f);
       end;
    end;
end;

{********************************************************************************}
{ Funcin que inicializa los datos del juego.                                    }
{********************************************************************************}
function InitJuego (var Nucleo: tNucleo): boolean;
var
   Resultado: boolean;
begin
   Resultado := false;

   assign(Nucleo.Errlog, 'Log.txt');
   rewrite(Nucleo.Errlog);

   {-----------------------------------------------------------------------------}
   { Activar el modo13h.                                                         }
   {-----------------------------------------------------------------------------}
   if M13hActivar then
    begin
      {--------------------------------------------------------------------------}
      { Activar el ratn, para luego ocultar el cursor, limitar su area de       }
      { movimiento y actualizar el estado del ratn. Luego cargamos las texturas }
      { e indicamos el estado actual del juego, para que vaya al men.           }
      {--------------------------------------------------------------------------}
      if RatonActivar > 0 then
       begin
         RatonOcultar;
         RatonLimitar(0, 0, 304, 184);
         RatonEstado(Nucleo.Raton);

         CargarTexturas(Nucleo);

         InitPartidas(Nucleo);

         Nucleo.Juego.Estado := EST_MENU;

         Resultado := true;
       end
      {--------------------------------------------------------------------------}
      { Si no se puede activar el ratn lanzar un aviso de error.                }
      {--------------------------------------------------------------------------}
      else
       begin
         M13hDesactivar;
         writeln('No se ha podido activar el ratn!');
         readkey;
       end;
    end
   {-----------------------------------------------------------------------------}
   { Si no se pudo activar el modo13h lanzar aviso de error.                     }
   {-----------------------------------------------------------------------------}
   else
    begin
      writeln('No se ha podido cambiar el modo de pantalla!');
      readkey;
    end;

   {-----------------------------------------------------------------------------}
   { Devolver el resultado final de la funcin.                                  }
   {-----------------------------------------------------------------------------}
   InitJuego := Resultado;
end;

{********************************************************************************}
{ Funcin que borra los datos del juego.                                         }
{********************************************************************************}
procedure FinJuego (var Nucleo: tNucleo);
begin
   {-----------------------------------------------------------------------------}
   { Borra las imagenes cargadas.                                                }
   {-----------------------------------------------------------------------------}
   M13hBorrarImagen(Nucleo.Texturas.Menu);
   M13hBorrarImagen(Nucleo.Texturas.Tablero);
   M13hBorrarImagen(Nucleo.Texturas.Botones);
   M13hBorrarImagen(Nucleo.Texturas.Fichas);
   M13hBorrarImagen(Nucleo.Texturas.Cursor);

   {-----------------------------------------------------------------------------}
   { Borra la fuente cargada.                                                    }
   {-----------------------------------------------------------------------------}
   FuenteDescargar(Nucleo.Fuente);

   {-----------------------------------------------------------------------------}
   { Desactiva el modo13h.                                                       }
   {-----------------------------------------------------------------------------}
   M13hDesactivar;

   close(Nucleo.Errlog);
end;

{********************************************************************************}
end.
{********************************************************************************}